#include <rdm6300.h>
#define RDM6300_RX_PIN 2                        //rfid module to arduino pin 2(Rx)
Rdm6300 rdm6300;
int led = 6;                                      //Led pin to arduino pin 6
int lock = 10;                                    //mosfet/solenoid to arduino pin 10
int buzzer = 7;                                   //buzzer to arduino pin 7
const int buttonPin = 12;                         //reset button to arduino pin 12
int buttonState = 0;                              //to check whether reset button pressed or not
  
int brightness = 20;                              //for brightness of led
int fadeAmount = 5;                               //fadeamount of led

int value =0;                                     //initial state of ID



//Setup for arduino pin code
void setup() { 
Serial.begin(9600);                                //serial start
rdm6300.begin(RDM6300_RX_PIN);                     //serial start for module
Serial.println("\nPlace RFID tag near the rdm6300...");                                  
pinMode(led, OUTPUT);                              //arduino pin 6 set as output
pinMode(lock, OUTPUT);                             //arduino pin 10 set as output
pinMode(buzzer, OUTPUT);                           //arduino pin 7 set as output
 pinMode(buttonPin, INPUT);                        //arduino pin 12 set as intput
} 



//For led fading code
void fade() {
  analogWrite(led, brightness);                    //print led brightness
  brightness = brightness + fadeAmount;            //brightness increasing by fadeamount
  if (brightness == 20 || brightness == 150) {     //brightness increasing from 20 to 200
    fadeAmount = -fadeAmount ;                     //brightness decreasing
  }
  delay(50);                                       //time needed for fading
}



//For buzzer alarm code
void buzzeron(){
digitalWrite(buzzer, HIGH);                        //buzzer on
delay(100);                                        //on for 100ms
digitalWrite(buzzer, LOW);                         //buzzer off
delay(100);                                        //off for 100ms
digitalWrite(buzzer, HIGH);                        //buzzer on
delay(100);                                        //on for 100ms
digitalWrite(buzzer,LOW);                          //buzzer off
delay(50);                                        //off for 50ms
}





//Reading the RFID card
void readTags() {
value = 0;                                       //initial ok set to 0

if (rdm6300.get_new_tag_id()){                   //rfid card availability check
delay(10);                                       //wait for read card
value = rdm6300.get_tag_id();                    //store new value of RFID tag
Serial.println(value);                           // print rfid tag
}
if(value == 00000 || value == 00000 || value == 00000 || value == 00000 || value == 0000) {          //if id of newtag matches with card; write the correct codes here
Serial.println("Accepted");                      //serial monitor check
digitalWrite(lock, HIGH);                        //solenoid on
digitalWrite(led, HIGH);                         //led fading stops and stays on
digitalWrite(buzzer,HIGH);                        //buzzer on
delay(50);                                       //buzzer on for 50ms
digitalWrite(buzzer,LOW);                        //buzzer off
delay(1000);                                     //solenoid on for 1second
digitalWrite(lock,LOW);                          //solenoid off
digitalWrite(led, LOW);
                                        
rdm6300.end();                                   //IMPORTANT- removes multiple read
rdm6300.begin(RDM6300_RX_PIN);                   //IMPORTANT- removes multiple read
}

else if(value == 0){
                                                 //do nothing(fade continues
}
else {                                           //if value of no tag matches
Serial.println("Rejected");                      //serial monitor check
digitalWrite(led,LOW);                           //led turned off
buzzeron();                                      //buzzer alarm to indicate wrong rfid
delay(50);                                      //buzzer alarm on for 200ms
                                   
rdm6300.end();                                   //IMPORTANT- removes multiple read
rdm6300.begin(RDM6300_RX_PIN);                   //IMPORTANT- removes multiple read
}
}



//Repeating code
void loop() {
buttonState = digitalRead(buttonPin);            //reset button state check
  if (buttonState == HIGH) {                     //if reset button has been pressed
Serial.println("Accepted");                      //serial monitor check
digitalWrite(lock, HIGH);                        //solenoid on
digitalWrite(led, HIGH);                         //led fading stops and stays on
digitalWrite(buzzer,HIGH);                        //buzzer on
delay(50);                                       //buzzer on for 50ms
digitalWrite(buzzer,LOW);                        //buzzer off
delay(1000);                                     //solenoid on for 1second
digitalWrite(led, LOW);
digitalWrite(lock,LOW);                          //solenoid off
delay(2000);
  }
  else {                                         //if reset button not pressed
    digitalWrite(lock, LOW);                     //solenoid off
    digitalWrite(led, LOW);
  }
 
 readTags();                                     //check tag repeatedly
// fade();                                         //led fading always on
}
